////////////////////////////////////////////////////////

var video_mode = 7; // 800x600
var video_depth = 32; // 32 bits
//var video_screen = 1; // start the game in full screen mode

var dead_birds = 0;
var bullet_speed;
var bullets = 10; // number of bullets

//////////////////////////////////////////////////////////////

font arial_font = <arial14.pcx>, 19, 22; 

//////////////////////////////////////////////////////////////

bmap cursor_pcx = <cursor.pcx>; // cursor bitmap 

//////////////////////////////////////////////////////////////

sound beep_sound = <beep.wav>;
sound enemyshot_snd = <enemyshot.wav>;
sound playershot_snd = <playershot.wav>;
sound enemydead_snd = <dead.wav>;

//////////////////////////////////////////////////////////////

function move_bullet();
function remove_bullets();
function player_shoots();
function move_crows();
function kill_crows();

//////////////////////////////////////////////////////////////

string moorhuhn_wmb = <moorhuhn.wmb>;

string info_str = "Health:          Bullets:          Bodies:"; 
string bullet_mdl = <bullet.mdl>;
string crow_mdl = <crow.mdl>;

///////////////////////////////////////////////////////////////

panel cursor_pan
{
	bmap = cursor_pcx;
	pos_x = 392; // (800 - 16) / 2
	pos_y = 292; // (600 - 16) / 2
	flags = overlay, visible;
}

panel info_pan // displays the bullets and the number of birds that were shot
{
	pos_x = 0;
	pos_y = 0;
	digits = 10, 575, 4, arial_font, 1, 100; // player's health is always 100
	digits = 330, 575, 4, arial_font, 1, bullets;
	digits = 660, 575, 4, arial_font, 1, dead_birds;
	flags = visible;
}

text health_text // displays the text
{
	pos_x = 0;
	pos_y = 550;
	font = arial_font;	
	string = info_str;
	flags = visible;
}

////////////////////////////////////////////////////////////////

function main()
{
	level_load (moorhuhn_wmb);
}	

action my_player // attach this action to the player
{
	player = my; // I'm the player
	player.invisible = on; // and I'm invisible - who cares?
	camera.x = player.x;
	camera.y = player.y;
	camera.z = player.z; // choose a convenient position for the player to get a good camera
	camera.pan = 90; // initial camera.pan position
	while (1) // as long as the player is alive
	{
		camera.tilt += 10 * mouse_force.y * time_step;
		camera.tilt = clamp (camera.tilt, -30, 30);
		//if (camera.tilt < -25) {camera.tilt += 1;}
		//if (camera.tilt > 25) {camera.tilt -= 1;}
		camera.pan -= 10 * mouse_force.x * time_step; 
		//if (camera.pan < 60) {camera.pan += 1;} // 90 - 30
		//if (camera.pan > 120) {camera.pan -= 1;} // 90 + 30
		camera.pan = clamp (camera.pan, 45, 135);
		if (mouse_left == 1 && bullets > 0)
		{
			player_shoots();
		}
		player.pan = camera.pan; // rotate the player too
		player.tilt = camera.tilt; // not just the camera
		if ((mouse_right == 1) && (bullets == 0)) // right click to reload the gun
		{
			bullets = 10;
			while (mouse_right == 1) {wait (1);}	
		}
		wait (1); 
	}
}

function player_shoots()
{
	proc_kill(4);
	while (mouse_left == 1) {wait (1);}
	snd_play (playershot_snd, 70, 0);
	ent_create (bullet_mdl, player.pos, move_bullet);
	bullets -= 1; // you have used a bullet
}

function move_bullet()
{
	wait (1);
	if (my == null) {return;}
	my.enable_entity = on;
	my.enable_block = on;
	my.event = remove_bullets;
	my.passable = on;
	my.pan = you.pan;
	my.tilt = you.tilt;

	my.skill1 = 0;
	bullet_speed.x = 500;
	bullet_speed.y = 0;
	bullet_speed.z = 0;
	bullet_speed *= time_step;
	while (my.skill1 < 50)
	{
		if (my == null) {return;}
		if (my.skill1 < 0.1)  // don't collide with the creator
		{
			my.passable = on;
		}
		else	
		{
			my.passable = off;
		}
		my.skill1 += 0.1 * time_step;
		ent_move (bullet_speed, nullvector);
		wait (1);
	}
	ent_remove (my);
}

function remove_bullets()
{
	wait (1);
	ent_remove (my);
}

starter generate_birds()
{
	sleep (1); // wait until the level is loaded
	while (1)
	{
		temp.x = -1000;
		temp.y = random (1000);
		temp.z = 100 + random (500);
		ent_create (crow_mdl, temp.x, move_crows);
		sleep (3); // generate a crow every 3 seconds
	}
}

function move_crows()
{
	my.enable_impact = on;
	my.event = kill_crows;
	var crow_speed;
	crow_speed = 5 + random(5);
	while ((my.x < 1250) && (my.skill40 == 0))
	{
		my.x += crow_speed * time_step;
		ent_animate (me, "walk", my.skill42, anm_cycle);	
		my.skill42 += 5 * time;
		wait (1);
	}
}

function kill_crows()
{
	my.skill40 = 1; // stop the crow
	my.invisible = on; // and make it invisible
	my.enable_impact = off; // can't be shot from now on
	my.event = null;
	dead_birds += 1;
	my.skill10 = 0;
	snd_play (enemydead_snd, 70, 0); 
	sleep (0.5);
	ent_remove (my);
}
